Source-Changes-HG archive
[Date Prev][Date Next][Thread Prev][Thread Next][Date Index][Thread Index][Old Index]
[src/trunk]: src/tests/sbin/ifconfig Add a test case for PR bin/55389.
details: https://anonhg.NetBSD.org/src/rev/a3ff4c28e37a
branches: trunk
changeset: 935076:a3ff4c28e37a
user: jruoho <jruoho%NetBSD.org@localhost>
date: Wed Jun 24 09:11:26 2020 +0000
description:
Add a test case for PR bin/55389.
diffstat:
distrib/sets/lists/tests/mi | 3 +-
tests/sbin/ifconfig/Makefile | 4 +-
tests/sbin/ifconfig/t_repeated_scan.sh | 87 ++++++++++++++++++++++++++++++++++
3 files changed, 91 insertions(+), 3 deletions(-)
diffs (123 lines):
diff -r 593cfb3be95e -r a3ff4c28e37a distrib/sets/lists/tests/mi
--- a/distrib/sets/lists/tests/mi Wed Jun 24 08:27:47 2020 +0000
+++ b/distrib/sets/lists/tests/mi Wed Jun 24 09:11:26 2020 +0000
@@ -1,4 +1,4 @@
-# $NetBSD: mi,v 1.843 2020/06/12 11:04:44 roy Exp $
+# $NetBSD: mi,v 1.844 2020/06/24 09:11:26 jruoho Exp $
#
# Note: don't delete entries from here - mark them as "obsolete" instead.
#
@@ -3990,6 +3990,7 @@
./usr/tests/sbin/ifconfig/Atffile tests-sbin-tests compattestfile,atf
./usr/tests/sbin/ifconfig/Kyuafile tests-sbin-tests compattestfile,atf,kyua
./usr/tests/sbin/ifconfig/t_nonexistent tests-sbin-tests compattestfile,atf
+./usr/tests/sbin/ifconfig/t_repeated_scan tests-sbin-tests compattestfile,atf
./usr/tests/sbin/newfs tests-sbin-tests compattestfile,atf
./usr/tests/sbin/newfs/Atffile tests-sbin-tests compattestfile,atf
./usr/tests/sbin/newfs/Kyuafile tests-sbin-tests compattestfile,atf,kyua
diff -r 593cfb3be95e -r a3ff4c28e37a tests/sbin/ifconfig/Makefile
--- a/tests/sbin/ifconfig/Makefile Wed Jun 24 08:27:47 2020 +0000
+++ b/tests/sbin/ifconfig/Makefile Wed Jun 24 09:11:26 2020 +0000
@@ -1,9 +1,9 @@
-# $NetBSD: Makefile,v 1.1 2011/05/03 06:13:06 jruoho Exp $
+# $NetBSD: Makefile,v 1.2 2020/06/24 09:11:26 jruoho Exp $
.include <bsd.own.mk>
TESTSDIR= ${TESTSBASE}/sbin/ifconfig
-TESTS_SH= t_nonexistent
+TESTS_SH= t_nonexistent t_repeated_scan
.include <bsd.test.mk>
diff -r 593cfb3be95e -r a3ff4c28e37a tests/sbin/ifconfig/t_repeated_scan.sh
--- /dev/null Thu Jan 01 00:00:00 1970 +0000
+++ b/tests/sbin/ifconfig/t_repeated_scan.sh Wed Jun 24 09:11:26 2020 +0000
@@ -0,0 +1,87 @@
+# $NetBSD: t_repeated_scan.sh,v 1.1 2020/06/24 09:11:26 jruoho Exp $
+#
+# Copyright (c) 2020 The NetBSD Foundation, Inc.
+# All rights reserved.
+#
+# This code is derived from software contributed to The NetBSD Foundation
+# by Jukka Ruohonen.
+#
+# Redistribution and use in source and binary forms, with or without
+# modification, are permitted provided that the following conditions
+# are met:
+# 1. Redistributions of source code must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+# 2. Redistributions in binary form must reproduce the above copyright
+# notice, this list of conditions and the following disclaimer in the
+# documentation and/or other materials provided with the distribution.
+#
+# THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
+# ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
+# TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
+# PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
+# BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
+# CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
+# SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
+# INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
+# CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
+# ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
+# POSSIBILITY OF SUCH DAMAGE.
+
+atf_test_case repeated_scan
+repeated_scan_head() {
+ atf_set "descr" "Test with ifconfig(8) that repeated 802.11 " \
+ "scanning does not cause a panic (PR bin/55389)"
+}
+
+repeated_scan_body() {
+
+ # Even though this should amount to a "few minutes",
+ # try to still avoid stalling any automated test runs.
+ #
+ n=15
+
+ pkill -9 hostapd
+ pkill -9 wpa_supplicant
+
+ for i in $(ifconfig -l); do
+
+ state="up"
+ ifconfig -s $i
+
+ if [ $? -eq 1 ]; then
+
+ state="down"
+ ifconfig $i up
+
+ if [ ! $? -eq 0 ]; then
+ echo "Failed to set $i up"
+ continue
+ fi
+ fi
+
+ sleep 1
+ ifconfig $i list scan >/dev/null 2>&1
+
+ if [ ! $? -eq 0 ]; then
+ echo "Skipping $i; scan not supported"
+ continue
+ fi
+
+ while [ $n -gt 0 ]; do
+ echo "Test $n for $i"
+ ifconfig $i list scan >/dev/null 2>&1
+ n=$(expr $n - 1)
+ done
+
+ ifconfig $i $state
+ echo "Restored state of $i to $state"
+ sleep 1
+ done
+
+ /bin/sh /etc/rc.d/hostapd restart >/dev/null 2>&1
+ /bin/sh /etc/rc.d/wpa_supplicant restart >/dev/null 2>&1
+}
+
+atf_init_test_cases() {
+ atf_add_test_case repeated_scan
+}
Home |
Main Index |
Thread Index |
Old Index